package dynamic.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "dynamic.example", "dynamic.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "dynamic.example", "dynamic.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "dynamic.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static int _k = 0;
public static int _qq = 0;
public static int _ll = 0;
public static int _bv = 0;
public static int _ln = 0;
public static int _tx = 0;
public static String _lista = "";
public static String _nlist = "";
public anywheresoftware.b4a.objects.ButtonWrapper _btn1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn4 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
public anywheresoftware.b4a.objects.LabelWrapper _labela = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelb = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 40;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 42;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 42;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_bv = _qq;
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 49;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 51;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 47;BA.debugLine="End Sub";
return "";
}
public static String  _btn1_click() throws Exception{
 //BA.debugLineNum = 168;BA.debugLine="Sub Btn1_Click";
 //BA.debugLineNum = 169;BA.debugLine="If Btn1.Text = \"CLOSE\" Then";
if ((mostCurrent._btn1.getText()).equals("CLOSE")) { 
 //BA.debugLineNum = 170;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 171;BA.debugLine="Lbl.Text = \"\"";
mostCurrent._lbl.setText((Object)(""));
 //BA.debugLineNum = 172;BA.debugLine="Btn1.Text = \"Single Label\"";
mostCurrent._btn1.setText((Object)("Single Label"));
 }else {
 //BA.debugLineNum = 174;BA.debugLine="CreaLab";
_crealab();
 //BA.debugLineNum = 175;BA.debugLine="Btn1.Text = \"CLOSE\"";
mostCurrent._btn1.setText((Object)("CLOSE"));
 };
 //BA.debugLineNum = 177;BA.debugLine="End Sub";
return "";
}
public static String  _btn2_click() throws Exception{
 //BA.debugLineNum = 158;BA.debugLine="Sub Btn2_Click";
 //BA.debugLineNum = 159;BA.debugLine="If Btn2.Text = \"CLOSE\" Then";
if ((mostCurrent._btn2.getText()).equals("CLOSE")) { 
 //BA.debugLineNum = 160;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 161;BA.debugLine="Lbl.Text = \"\"";
mostCurrent._lbl.setText((Object)(""));
 //BA.debugLineNum = 162;BA.debugLine="Btn2.Text = \"3 Horiz.Label\"";
mostCurrent._btn2.setText((Object)("3 Horiz.Label"));
 }else {
 //BA.debugLineNum = 164;BA.debugLine="CreaLab1";
_crealab1();
 //BA.debugLineNum = 165;BA.debugLine="Btn2.Text = \"CLOSE\"";
mostCurrent._btn2.setText((Object)("CLOSE"));
 };
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}
public static String  _btn3_click() throws Exception{
 //BA.debugLineNum = 148;BA.debugLine="Sub Btn3_Click";
 //BA.debugLineNum = 149;BA.debugLine="If Btn3.Text = \"CLOSE\" Then";
if ((mostCurrent._btn3.getText()).equals("CLOSE")) { 
 //BA.debugLineNum = 150;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 151;BA.debugLine="Lbl.Text = \"\"";
mostCurrent._lbl.setText((Object)(""));
 //BA.debugLineNum = 152;BA.debugLine="Btn3.Text = \"3 Vert.Label\"";
mostCurrent._btn3.setText((Object)("3 Vert.Label"));
 }else {
 //BA.debugLineNum = 154;BA.debugLine="CreaLab2";
_crealab2();
 //BA.debugLineNum = 155;BA.debugLine="Btn3.Text = \"CLOSE\"";
mostCurrent._btn3.setText((Object)("CLOSE"));
 };
 //BA.debugLineNum = 157;BA.debugLine="End Sub";
return "";
}
public static String  _btn4_click() throws Exception{
 //BA.debugLineNum = 136;BA.debugLine="Sub Btn4_Click";
 //BA.debugLineNum = 137;BA.debugLine="If Btn4.Text = \"CLOSE\" Then";
if ((mostCurrent._btn4.getText()).equals("CLOSE")) { 
 //BA.debugLineNum = 138;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 139;BA.debugLine="Lbl.Text = \"\"";
mostCurrent._lbl.setText((Object)(""));
 //BA.debugLineNum = 140;BA.debugLine="Btn4.Text = \"All together\"";
mostCurrent._btn4.setText((Object)("All together"));
 }else {
 //BA.debugLineNum = 142;BA.debugLine="CreaLab";
_crealab();
 //BA.debugLineNum = 143;BA.debugLine="CreaLab1";
_crealab1();
 //BA.debugLineNum = 144;BA.debugLine="CreaLab2";
_crealab2();
 //BA.debugLineNum = 145;BA.debugLine="Btn4.Text = \"CLOSE\"";
mostCurrent._btn4.setText((Object)("CLOSE"));
 };
 //BA.debugLineNum = 147;BA.debugLine="End Sub";
return "";
}
public static String  _clearlist() throws Exception{
int _m = 0;
 //BA.debugLineNum = 179;BA.debugLine="Sub ClearList";
 //BA.debugLineNum = 180;BA.debugLine="qq = Activity.NumberOfViews : LN = qq-1";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 180;BA.debugLine="qq = Activity.NumberOfViews : LN = qq-1";
_ln = (int) (_qq-1);
 //BA.debugLineNum = 181;BA.debugLine="For m = LN To BV Step -1";
{
final int step140 = (int) (-1);
final int limit140 = _bv;
for (_m = _ln; (step140 > 0 && _m <= limit140) || (step140 < 0 && _m >= limit140); _m = ((int)(0 + _m + step140))) {
 //BA.debugLineNum = 182;BA.debugLine="Activity.RemoveViewAt(m)";
mostCurrent._activity.RemoveViewAt(_m);
 }
};
 //BA.debugLineNum = 184;BA.debugLine="End Sub";
return "";
}
public static String  _crealab() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _dynlab = null;
 //BA.debugLineNum = 53;BA.debugLine="Sub CreaLab";
 //BA.debugLineNum = 54;BA.debugLine="Dim DynLab As Label";
_dynlab = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 55;BA.debugLine="DynLab.Initialize(\"Label\")";
_dynlab.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 56;BA.debugLine="DynLab.TextSize = 14";
_dynlab.setTextSize((float) (14));
 //BA.debugLineNum = 57;BA.debugLine="DynLab.TextColor = Colors.Blue";
_dynlab.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 58;BA.debugLine="DynLab.Color = Colors.White";
_dynlab.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 59;BA.debugLine="DynLab.Typeface = Typeface.DEFAULT_BOLD";
_dynlab.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 //BA.debugLineNum = 60;BA.debugLine="DynLab.Gravity = Gravity.CENTER_VERTICAL";
_dynlab.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL);
 //BA.debugLineNum = 61;BA.debugLine="DynLab.Gravity = Gravity.CENTER_HORIZONTAL";
_dynlab.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL);
 //BA.debugLineNum = 62;BA.debugLine="DynLab.Tag = 0";
_dynlab.setTag((Object)(0));
 //BA.debugLineNum = 63;BA.debugLine="DynLab.Visible = True";
_dynlab.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 64;BA.debugLine="Activity.AddView(DynLab, 0, 0, 150, 30)";
mostCurrent._activity.AddView((android.view.View)(_dynlab.getObject()),(int) (0),(int) (0),(int) (150),(int) (30));
 //BA.debugLineNum = 65;BA.debugLine="DynLab.Text = \"This is an example\"";
_dynlab.setText((Object)("This is an example"));
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _crealab1() throws Exception{
int _x = 0;
anywheresoftware.b4a.objects.LabelWrapper _dynlaba = null;
 //BA.debugLineNum = 68;BA.debugLine="Sub CreaLab1";
 //BA.debugLineNum = 69;BA.debugLine="For x = 1 To 3";
{
final int step37 = 1;
final int limit37 = (int) (3);
for (_x = (int) (1); (step37 > 0 && _x <= limit37) || (step37 < 0 && _x >= limit37); _x = ((int)(0 + _x + step37))) {
 //BA.debugLineNum = 70;BA.debugLine="Dim DynLabA As Label";
_dynlaba = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 71;BA.debugLine="DynLabA.Initialize(\"LabelA\")";
_dynlaba.Initialize(mostCurrent.activityBA,"LabelA");
 //BA.debugLineNum = 72;BA.debugLine="DynLabA.Visible = True";
_dynlaba.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 73;BA.debugLine="DynLabA.Color = Colors.White";
_dynlaba.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 74;BA.debugLine="DynLabA.TextColor = Colors.Black";
_dynlaba.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 75;BA.debugLine="DynLabA.Typeface = Typeface.DEFAULT_BOLD";
_dynlaba.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 //BA.debugLineNum = 76;BA.debugLine="DynLabA.Gravity = Gravity.CENTER_VERTICAL";
_dynlaba.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL);
 //BA.debugLineNum = 77;BA.debugLine="DynLabA.Gravity = Gravity.CENTER_HORIZONTAL";
_dynlaba.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL);
 //BA.debugLineNum = 78;BA.debugLine="DynLabA.Tag = x";
_dynlaba.setTag((Object)(_x));
 //BA.debugLineNum = 79;BA.debugLine="Activity.AddView(DynLabA, (10dip + (x-1) * (100dip+1dip)), 40dip, 100dip, 30dip) 'Allineamento orizzontale";
mostCurrent._activity.AddView((android.view.View)(_dynlaba.getObject()),(int) ((anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))+(_x-1)*(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)));
 //BA.debugLineNum = 82;BA.debugLine="DynLabA.Text = x";
_dynlaba.setText((Object)(_x));
 }
};
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static String  _crealab2() throws Exception{
int _x = 0;
anywheresoftware.b4a.objects.LabelWrapper _dynlabb = null;
 //BA.debugLineNum = 86;BA.debugLine="Sub CreaLab2";
 //BA.debugLineNum = 87;BA.debugLine="Lista = \"Object A,Object B, Object C,\"";
mostCurrent._lista = "Object A,Object B, Object C,";
 //BA.debugLineNum = 88;BA.debugLine="For x = 1 To 3";
{
final int step53 = 1;
final int limit53 = (int) (3);
for (_x = (int) (1); (step53 > 0 && _x <= limit53) || (step53 < 0 && _x >= limit53); _x = ((int)(0 + _x + step53))) {
 //BA.debugLineNum = 89;BA.debugLine="Dim DynLabB As Label";
_dynlabb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 90;BA.debugLine="DynLabB.Initialize(\"LabelB\")";
_dynlabb.Initialize(mostCurrent.activityBA,"LabelB");
 //BA.debugLineNum = 91;BA.debugLine="DynLabB.Visible = True";
_dynlabb.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 92;BA.debugLine="DynLabB.Color = Colors.White";
_dynlabb.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 93;BA.debugLine="DynLabB.TextColor = Colors.Black";
_dynlabb.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 94;BA.debugLine="DynLabB.Typeface = Typeface.DEFAULT_BOLD";
_dynlabb.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 //BA.debugLineNum = 95;BA.debugLine="DynLabB.Gravity = Gravity.CENTER_VERTICAL";
_dynlabb.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL);
 //BA.debugLineNum = 96;BA.debugLine="DynLabB.Gravity = Gravity.CENTER_HORIZONTAL";
_dynlabb.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL);
 //BA.debugLineNum = 97;BA.debugLine="DynLabB.Tag = x";
_dynlabb.setTag((Object)(_x));
 //BA.debugLineNum = 100;BA.debugLine="Activity.AddView(DynLabB, 10, (80 + (x-1) * (30dip + 5dip)), 100Dip, 30dip) 'Allineamento verticale";
mostCurrent._activity.AddView((android.view.View)(_dynlabb.getObject()),(int) (10),(int) ((80+(_x-1)*(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (5))))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)));
 //BA.debugLineNum = 101;BA.debugLine="DynLabB.Text = x";
_dynlabb.setText((Object)(_x));
 //BA.debugLineNum = 102;BA.debugLine="TX = (Lista).IndexOf(\",\")";
_tx = (mostCurrent._lista).indexOf(",");
 //BA.debugLineNum = 103;BA.debugLine="DynLabB.Text = Lista.SubString2(0, TX)";
_dynlabb.setText((Object)(mostCurrent._lista.substring((int) (0),_tx)));
 //BA.debugLineNum = 104;BA.debugLine="Nlist = Lista.SubString2(TX+1, Lista.Length) '(remaining Lista string)";
mostCurrent._nlist = mostCurrent._lista.substring((int) (_tx+1),mostCurrent._lista.length());
 //BA.debugLineNum = 105;BA.debugLine="Lista = Nlist";
mostCurrent._lista = mostCurrent._nlist;
 }
};
 //BA.debugLineNum = 107;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim k, qq, LL, BV, LN, TX As Int";
_k = 0;
_qq = 0;
_ll = 0;
_bv = 0;
_ln = 0;
_tx = 0;
 //BA.debugLineNum = 25;BA.debugLine="Dim Lista, Nlist As String";
mostCurrent._lista = "";
mostCurrent._nlist = "";
 //BA.debugLineNum = 26;BA.debugLine="Private Btn1 As Button";
mostCurrent._btn1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private Btn2 As Button";
mostCurrent._btn2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private Btn3 As Button";
mostCurrent._btn3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private Btn4 As Button";
mostCurrent._btn4 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Private Lbl As Label";
mostCurrent._lbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Dim LabelA As Label";
mostCurrent._labela = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Dim LabelB As Label";
mostCurrent._labelb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _label_click() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _dynlab = null;
 //BA.debugLineNum = 109;BA.debugLine="Sub Label_Click";
 //BA.debugLineNum = 110;BA.debugLine="Dim DynLab As Label";
_dynlab = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 111;BA.debugLine="DynLab.Initialize(\"Label\")";
_dynlab.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 112;BA.debugLine="DynLab = Sender";
_dynlab.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 113;BA.debugLine="k = DynLab.Tag";
_k = (int)(BA.ObjectToNumber(_dynlab.getTag()));
 //BA.debugLineNum = 114;BA.debugLine="LL = DynLab.Left";
_ll = _dynlab.getLeft();
 //BA.debugLineNum = 115;BA.debugLine="Lbl.Text = \"Button N° \" & k & \" - Left Coordinate of Label = \" & LL";
mostCurrent._lbl.setText((Object)("Button N° "+BA.NumberToString(_k)+" - Left Coordinate of Label = "+BA.NumberToString(_ll)));
 //BA.debugLineNum = 116;BA.debugLine="End Sub";
return "";
}
public static String  _labela_click() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _dynlaba = null;
 //BA.debugLineNum = 118;BA.debugLine="Sub LabelA_Click";
 //BA.debugLineNum = 119;BA.debugLine="Dim DynLabA As Label";
_dynlaba = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 120;BA.debugLine="DynLabA.Initialize(\"LabelA\")";
_dynlaba.Initialize(mostCurrent.activityBA,"LabelA");
 //BA.debugLineNum = 121;BA.debugLine="DynLabA = Sender";
_dynlaba.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 122;BA.debugLine="k = DynLabA.Tag";
_k = (int)(BA.ObjectToNumber(_dynlaba.getTag()));
 //BA.debugLineNum = 123;BA.debugLine="LL = DynLabA.Left";
_ll = _dynlaba.getLeft();
 //BA.debugLineNum = 124;BA.debugLine="Lbl.Text = \"Button N° \" & k & \" - Left Coordinate of Label = \" & LL";
mostCurrent._lbl.setText((Object)("Button N° "+BA.NumberToString(_k)+" - Left Coordinate of Label = "+BA.NumberToString(_ll)));
 //BA.debugLineNum = 125;BA.debugLine="End Sub";
return "";
}
public static String  _labelb_click() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _dynlabb = null;
 //BA.debugLineNum = 127;BA.debugLine="Sub LabelB_Click";
 //BA.debugLineNum = 128;BA.debugLine="Dim DynLabB As Label";
_dynlabb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 129;BA.debugLine="DynLabB.Initialize(\"Label\")";
_dynlabb.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 130;BA.debugLine="DynLabB = Sender";
_dynlabb.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 131;BA.debugLine="k = DynLabB.Tag";
_k = (int)(BA.ObjectToNumber(_dynlabb.getTag()));
 //BA.debugLineNum = 132;BA.debugLine="LL = DynLabB.Left";
_ll = _dynlabb.getLeft();
 //BA.debugLineNum = 133;BA.debugLine="Lbl.Text = \"Button N° \" & k & \" - Left Coordinate of Label = \" & LL";
mostCurrent._lbl.setText((Object)("Button N° "+BA.NumberToString(_k)+" - Left Coordinate of Label = "+BA.NumberToString(_ll)));
 //BA.debugLineNum = 134;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
}
